Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1796)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1797)
@@ -2890,35 +3146,11 @@
     REAL(wp), DIMENSION(1) ::  dtl         !:
 
-!
-!-- First find the smallest native time step of all the clients of the current
-!-- server.
-    dtl(1) = 999999.9_wp
-    DO  m = 1, SIZE( pmc_server_for_client )-1
-       client_id = pmc_server_for_client(m)
-       IF ( myid==0 )  THEN
-          CALL pmc_recv_from_client( client_id, dtc, SIZE( dtc ), 0, 101, ierr )
-          dtl(1) = MIN( dtl(1), dtc(1) )
-          dt_3d  = dtl(1)
-       ENDIF
-    ENDDO
-
-!
-!-- Broadcast the unified time step to all server processes
-    CALL MPI_BCAST( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
 
     DO  m = 1, SIZE( PMC_Server_for_Client )-1
        client_id = PMC_Server_for_Client(m)
-       CALL cpu_log( log_point_s(70), 'pmc sync', 'start' )
-
-!
-!--    Send the new time step to all the clients of the current server
-       IF ( myid == 0 )  THEN
-          CALL pmc_send_to_client( client_id, dtl, SIZE( dtl ), 0, 102, ierr )
-       ENDIF
-       CALL cpu_log( log_point_s(70), 'pmc sync', 'stop' )
        
        IF ( direction == server_to_client )  THEN
           CALL cpu_log( log_point_s(71), 'pmc server send', 'start' )
-          CALL pmc_s_fillbuffer( client_id, waittime=waittime )
+          CALL pmc_s_fillbuffer( client_id )
           CALL cpu_log( log_point_s(71), 'pmc server send', 'stop' )
        ELSE
@@ -2936,13 +3168,16 @@
 !
 !--          Inside buildings/topography reset velocities and TKE back to zero.
-!--          TO_DO: at least temperature should be included here immediately
 !--          Other scalars (pt, q, s, km, kh, p, sa, ...) are ignored at
 !--          present, maybe revise later.
              DO   i = nxlg, nxrg
                 DO   j = nysg, nyng
-                   u(nzb:nzb_u_inner(j,i),j,i) = 0.0_wp
-                   v(nzb:nzb_v_inner(j,i),j,i) = 0.0_wp
-                   w(nzb:nzb_w_inner(j,i),j,i) = 0.0_wp
-                   e(nzb:nzb_s_inner(j,i),j,i) = 0.0_wp
+                   u(nzb:nzb_u_inner(j,i),j,i)  = 0.0_wp
+                   v(nzb:nzb_v_inner(j,i),j,i)  = 0.0_wp
+                   w(nzb:nzb_w_inner(j,i),j,i)  = 0.0_wp
+                   e(nzb:nzb_s_inner(j,i),j,i)  = 0.0_wp
+                   pt(nzb:nzb_s_inner(j,i),j,i) = 0.0_wp
+                   IF ( humidity  .OR.  passive_scalar )  THEN
+                      q(nzb:nzb_s_inner(j,i),j,i) = 0.0_wp
+                   ENDIF
                 ENDDO
              ENDDO
@@ -2969,6 +3204,4 @@
     INTEGER(iwp) ::  jcn         !:
     
-    REAL(wp) ::  waittime    !:
-
     REAL(wp), DIMENSION(1) ::  dtl         !:
     REAL(wp), DIMENSION(1) ::  dts         !:
@@ -2977,16 +3210,4 @@
     dtl = dt_3d
     IF ( cpl_id > 1 )  THEN
-       CALL cpu_log( log_point_s(70), 'pmc sync', 'start' )
-       IF ( myid==0 )  THEN
-          CALL pmc_send_to_server( dtl, SIZE( dtl ), 0, 101, ierr )
-          CALL pmc_recv_from_server( dts, SIZE( dts ), 0, 102, ierr )
-          dt_3d = dts(1)
-       ENDIF
-
-!
-!--    Broadcast the unified time step to all server processes.
-       CALL MPI_BCAST( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
-       CALL cpu_log( log_point_s(70), 'pmc sync', 'stop' )
-
 !
 !--    Client domain boundaries in the server indice space.
@@ -2999,16 +3220,20 @@
 
           CALL cpu_log( log_point_s(73), 'pmc client recv', 'start' )
-          CALL pmc_c_getbuffer( WaitTime = WaitTime )
+          CALL pmc_c_getbuffer( )
           CALL cpu_log( log_point_s(73), 'pmc client recv', 'stop' )
 
+          CALL cpu_log( log_point_s(75), 'pmc interpolation', 'start' )
           CALL pmci_interpolation
+          CALL cpu_log( log_point_s(75), 'pmc interpolation', 'stop' )
 
        ELSE
 !
-!--       direction == server_to_client
+!--       direction == client_to_server
+          CALL cpu_log( log_point_s(76), 'pmc anterpolation', 'start' )
           CALL pmci_anterpolation
+          CALL cpu_log( log_point_s(76), 'pmc anterpolation', 'stop' )
 
           CALL cpu_log( log_point_s(74), 'pmc client send', 'start' )
-          CALL pmc_c_putbuffer( WaitTime = WaitTime )
+          CALL pmc_c_putbuffer( )
           CALL cpu_log( log_point_s(74), 'pmc client send', 'stop' )
 
@@ -3234,14 +3459,14 @@
 
       CALL pmci_anterp_tophat( u,  uc,  kctu, iflu, ifuu, jflo, jfuo, kflo,    &
-                               kfuo, nzb_u_inner, 'u' )
+                               kfuo, 'u' )
       CALL pmci_anterp_tophat( v,  vc,  kctu, iflo, ifuo, jflv, jfuv, kflo,    &
-                               kfuo, nzb_v_inner, 'v' )
+                               kfuo, 'v' )
       CALL pmci_anterp_tophat( w,  wc,  kctw, iflo, ifuo, jflo, jfuo, kflw,    &
-                               kfuw, nzb_w_inner, 'w' )
+                               kfuw, 'w' )
       CALL pmci_anterp_tophat( pt, ptc, kctu, iflo, ifuo, jflo, jfuo, kflo,    &
-                               kfuo, nzb_s_inner, 's' )
+                               kfuo, 's' )
       IF ( humidity  .OR.  passive_scalar )  THEN
          CALL pmci_anterp_tophat( q, qc, kctu, iflo, ifuo, jflo, jfuo, kflo,   &
-                                  kfuo, nzb_s_inner, 's' )
+                                  kfuo, 's' )
       ENDIF
 
@@ -3256,26 +3481,28 @@
 !--   Interpolation of ghost-node values used as the client-domain boundary
 !--   conditions. This subroutine handles the left and right boundaries. It is
-!--   based on trilinear interpolation. Constant dz is still assumed.
-!--   TO_DO:  constant dz is an important restriction and should be checked
-!--           somewhere in order to let users not run into this trap
+!--   based on trilinear interpolation.
+
       IMPLICIT NONE
 
-!--   TO_DO: wrap long lines in this and the remaining interp_tril routines
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT)          ::  f            !:
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN)                 ::  fc           !:
-      REAL(wp), DIMENSION(nzb:nzt_topo_nestbc,nys:nyn,1:2,0:ncorr-1), INTENT(IN) ::  logc_ratio   !: 
-      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)                                 ::  r1x          !:
-      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)                                 ::  r2x          !:
-      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)                                 ::  r1y          !:
-      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)                                 ::  r2y          !:
-      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)                                 ::  r1z          !:
-      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)                                 ::  r2z          !:
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
+                                      INTENT(INOUT) ::  f       !:
+      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
+                                      INTENT(IN)    ::  fc      !:
+      REAL(wp), DIMENSION(nzb:nzt_topo_nestbc,nys:nyn,1:2,0:ncorr-1),          &
+                                      INTENT(IN)    ::  logc_ratio   !:
+      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r1x     !:
+      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r2x     !:
+      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r1y     !:
+      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r2y     !:
+      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z     !:
+      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z     !:
       
-      INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN)                             ::  ic           !:
-      INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)                             ::  jc           !:
-      INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN)                   ::  kb           !:
-      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)                             ::  kc           !: 
-      INTEGER(iwp), DIMENSION(nzb:nzt_topo_nestbc,nys:nyn,1:2), INTENT(IN)       ::  logc         !: 
-      INTEGER(iwp)                                                               ::  nzt_topo_nestbc   !:
+      INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN)           ::  ic     !:
+      INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)           ::  jc     !:
+      INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN) ::  kb     !:
+      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc     !:
+      INTEGER(iwp), DIMENSION(nzb:nzt_topo_nestbc,nys:nyn,1:2),                &
+                                          INTENT(IN)           ::  logc   !:
+      INTEGER(iwp) ::  nzt_topo_nestbc   !:
 
       CHARACTER(LEN=1),INTENT(IN) ::  edge   !:
@@ -3312,8 +3539,9 @@
       
 ! 
-!--   Check which edge is to be handled: left or right. Note the assumption that the same PE never 
-!--   holds both left and right nest boundaries. Should this be changed?
+!--   Check which edge is to be handled
       IF ( edge == 'l' )  THEN
-         IF ( var == 'u' )  THEN   !  For u, nxl is a ghost node, but not for the other variables.
+!
+!--      For u, nxl is a ghost node, but not for the other variables
+         IF ( var == 'u' )  THEN
             i  = nxl
             ib = nxl - 1 
@@ -3327,6 +3555,6 @@
       ENDIF
       
-      DO  j = nys, nyn + 1
-         DO  k = kb(j,i), nzt + 1
+      DO  j = nys, nyn+1
+         DO  k = kb(j,i), nzt+1
             l = ic(i)
             m = jc(j)
@@ -3345,10 +3573,11 @@
 !--   Generalized log-law-correction algorithm.
 !--   Doubly two-dimensional index arrays logc(:,:,1:2) and log-ratio arrays 
-!--   logc_ratio(:,:,1:2,0:ncorr-1) have been precomputed in subroutine pmci_init_loglaw_correction.
+!--   logc_ratio(:,:,1:2,0:ncorr-1) have been precomputed in subroutine
+!--   pmci_init_loglaw_correction.
 !
 !--   Solid surface below the node 
       IF ( var == 'u' .OR. var == 'v' )  THEN           
          DO  j = nys, nyn
-            k = kb(j,i) + 1
+            k = kb(j,i)+1
             IF ( ( logc(k,j,1) /= 0 )  .AND.  ( logc(k,j,2) == 0 ) )  THEN
                k1 = logc(k,j,1)
@@ -3362,7 +3591,8 @@
 
 !
-!--   In case of non-flat topography, also vertical walls and corners need to be treated.
-!--   Only single and double wall nodes are corrected. Triple and higher-multiple wall nodes 
-!--   are not corrected as the log law would not be valid anyway in such locations.
+!--   In case of non-flat topography, also vertical walls and corners need to be
+!--   treated. Only single and double wall nodes are corrected. Triple and
+!--   higher-multiple wall nodes are not corrected as the log law would not be
+!--   valid anyway in such locations.
       IF ( topography /= 'flat' )  THEN
          IF ( var == 'u' .OR. var == 'w' )  THEN                 
@@ -3371,12 +3601,13 @@
 !--         Solid surface only on south/north side of the node                   
             DO  j = nys, nyn
-               DO  k = kb(j,i) + 1, nzt_topo_nestbc
+               DO  k = kb(j,i)+1, nzt_topo_nestbc
                   IF ( ( logc(k,j,2) /= 0 )  .AND.  ( logc(k,j,1) == 0 ) )  THEN
 
 !
-!--                  Direction of the wall-normal index is carried in as the sign of logc.            
+!--                  Direction of the wall-normal index is carried in as the
+!--                  sign of logc
                      jinc = SIGN( 1, logc(k,j,2) )
                      j1   = ABS( logc(k,j,2) )
-                     DO  jcorr=0, ncorr - 1
+                     DO  jcorr = 0, ncorr-1
                         jco = j + jinc * jcorr
                         f(k,jco,i) = logc_ratio(k,j,2,jcorr) * f(k,j1,i)
@@ -3396,10 +3627,12 @@
                   jinc = SIGN( 1, logc(k,j,2) )
                   j1   = ABS( logc(k,j,2) )                 
-                  DO  jcorr = 0, ncorr - 1
+                  DO  jcorr = 0, ncorr-1
                      jco = j + jinc * jcorr
-                     DO  kcorr = 0, ncorr - 1
+                     DO  kcorr = 0, ncorr-1
                         kco = k + kcorr
-                        f(kco,jco,i) = 0.5_wp * ( logc_ratio(k,j,1,kcorr) * f(k1,j,i)  &
-                                     + logc_ratio(k,j,2,jcorr) * f(k,j1,i) )
+                        f(kco,jco,i) = 0.5_wp * ( logc_ratio(k,j,1,kcorr) *    &
+                                                  f(k1,j,i)                    &
+                                                + logc_ratio(k,j,2,jcorr) *    &
+                                                  f(k,j1,i) )
                      ENDDO
                   ENDDO
@@ -3420,6 +3653,6 @@
             ENDDO
          ELSEIF ( edge == 'r' )  THEN           
-            DO  j = nys, nyn + 1
-               DO  k = kb(j,i), nzt + 1
+            DO  j = nys, nyn+1
+               DO  k = kb(j,i), nzt+1
                   f(k,j,i) = tkefactor_r(k,j) * f(k,j,i)
                ENDDO
@@ -3431,9 +3664,9 @@
 !--   Store the boundary values also into the other redundant ghost node layers
       IF ( edge == 'l' )  THEN
-         DO ibgp = -nbgp, ib
+         DO  ibgp = -nbgp, ib
             f(0:nzt+1,nysg:nyng,ibgp) = f(0:nzt+1,nysg:nyng,i)
          ENDDO
-      ELSE IF ( edge == 'r' )  THEN
-         DO ibgp = ib, nx + nbgp
+      ELSEIF ( edge == 'r' )  THEN
+         DO  ibgp = ib, nx+nbgp
             f(0:nzt+1,nysg:nyng,ibgp) = f(0:nzt+1,nysg:nyng,i)
          ENDDO
@@ -3444,6 +3677,7 @@
 
 
-   SUBROUTINE pmci_interp_tril_sn( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, r2z, kb, logc, logc_ratio, &
-                                  nzt_topo_nestbc, edge, var )
+   SUBROUTINE pmci_interp_tril_sn( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, &
+                                   r2z, kb, logc, logc_ratio,                  &
+                                   nzt_topo_nestbc, edge, var )
 
 !
@@ -3451,43 +3685,27 @@
 !--   conditions. This subroutine handles the south and north boundaries. 
 !--   This subroutine is based on trilinear interpolation.
-!--   Constant dz is still assumed.
-!
-!--                                      Antti Hellsten 22.2.2015.
-!
-!--   Rewritten so that all the coefficients and client-array indices are 
-!--   precomputed in the initialization phase by pmci_init_interp_tril.
-!
-!--                                      Antti Hellsten 3.3.2015.
-!
-!--   Constant dz no more assumed.
-!--                                      Antti Hellsten 23.3.2015.
-!
-!--   Adapted for non-flat topography. However, the near-wall velocities 
-!--   are log-corrected only over horifontal surfaces, not yet near vertical 
-!--   walls.
-!--                                      Antti Hellsten 26.3.2015.
-!
-!--   Indexing in the principal direction (j) is changed. Now, the nest-boundary 
-!--   values are interpolated only into the first ghost-node layers on each later 
-!--   boundary. These values are then simply copied to the second ghost-node layer.
-!
-!--                                      Antti Hellsten 6.10.2015.
+
       IMPLICIT NONE
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT)          ::  f                 !:
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN)                 ::  fc                !:
-      REAL(wp), DIMENSION(nzb:nzt_topo_nestbc,nxl:nxr,1:2,0:ncorr-1), INTENT(IN) ::  logc_ratio        !:
-      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)                                 ::  r1x               !:
-      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)                                 ::  r2x               !:
-      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)                                 ::  r1y               !:
-      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)                                 ::  r2y               !:
-      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)                                 ::  r1z               !:
-      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)                                 ::  r2z               !:
+
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
+                                      INTENT(INOUT) ::  f             !:
+      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
+                                      INTENT(IN)    ::  fc            !:
+      REAL(wp), DIMENSION(nzb:nzt_topo_nestbc,nxl:nxr,1:2,0:ncorr-1),          &
+                                      INTENT(IN)    ::  logc_ratio    !:
+      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r1x           !:
+      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r2x           !:
+      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r1y           !:
+      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r2y           !:
+      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z           !:
+      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z           !:
       
-      INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN)                             ::  ic                !:
-      INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)                             ::  jc                !:
-      INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN)                   ::  kb                !:
-      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)                             ::  kc                !:
-      INTEGER(iwp), DIMENSION(nzb:nzt_topo_nestbc,nxl:nxr,1:2), INTENT(IN)       ::  logc              !: 
-      INTEGER(iwp)                                                               ::  nzt_topo_nestbc   !:
+      INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN)           ::  ic    !:
+      INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)           ::  jc    !:
+      INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN) ::  kb    !:
+      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !:
+      INTEGER(iwp), DIMENSION(nzb:nzt_topo_nestbc,nxl:nxr,1:2),                &
+                                          INTENT(IN)           ::  logc  !:
+      INTEGER(iwp) ::  nzt_topo_nestbc   !:
 
       CHARACTER(LEN=1), INTENT(IN) ::  edge   !:
@@ -3521,8 +3739,9 @@
       
 !
-!--   Check which edge is to be handled: south or north. Note the assumption that the same PE never 
-!--   holds both south and north nest boundaries. Should this be changed?
+!--   Check which edge is to be handled: south or north
       IF ( edge == 's' )  THEN
-         IF ( var == 'v' )  THEN   !  For v, nys is a ghost node, but not for the other variables.
+!
+!--      For v, nys is a ghost node, but not for the other variables
+         IF ( var == 'v' )  THEN
             j  = nys
             jb = nys - 1 
@@ -3536,6 +3755,6 @@
       ENDIF
 
-      DO  i = nxl, nxr + 1
-         DO  k = kb(j,i), nzt + 1
+      DO  i = nxl, nxr+1
+         DO  k = kb(j,i), nzt+1
             l = ic(i)
             m = jc(j)
@@ -3554,5 +3773,6 @@
 !--   Generalized log-law-correction algorithm.
 !--   Multiply two-dimensional index arrays logc(:,:,1:2) and log-ratio arrays 
-!--   logc_ratio(:,:,1:2,0:ncorr-1) have been precomputed in subroutine pmci_init_loglaw_correction.
+!--   logc_ratio(:,:,1:2,0:ncorr-1) have been precomputed in subroutine
+!--   pmci_init_loglaw_correction.
 !
 !--   Solid surface below the node 
@@ -3562,5 +3782,5 @@
             IF ( ( logc(k,i,1) /= 0 )  .AND.  ( logc(k,i,2) == 0 ) )  THEN
                k1 = logc(k,i,1)
-               DO  kcorr = 0, ncorr - 1
+               DO  kcorr = 0, ncorr-1
                   kco = k + kcorr
                   f(kco,j,i) = logc_ratio(k,i,1,kcorr) * f(k1,j,i)
@@ -3571,8 +3791,9 @@
 
 !
-!--   In case of non-flat topography, also vertical walls and corners need to be treated.
-!--   Only single and double wall nodes are corrected. 
-!--   Triple and higher-multiple wall nodes are not corrected as it would be extremely complicated 
-!--   and the log law would not be valid anyway in such locations.
+!--   In case of non-flat topography, also vertical walls and corners need to be
+!--   treated. Only single and double wall nodes are corrected.
+!--   Triple and higher-multiple wall nodes are not corrected as it would be
+!--   extremely complicated and the log law would not be valid anyway in such
+!--   locations.
       IF ( topography /= 'flat' )  THEN
          IF ( var == 'v' .OR. var == 'w' )  THEN
@@ -3585,8 +3806,9 @@
 
 !
-!--                  Direction of the wall-normal index is carried in as the sign of logc.            
+!--                  Direction of the wall-normal index is carried in as the
+!--                  sign of logc
                      iinc = SIGN( 1, logc(k,i,2) )
                      i1  = ABS( logc(k,i,2) )
-                     DO  icorr = 0, ncorr - 1
+                     DO  icorr = 0, ncorr-1
                         ico = i + iinc * icorr
                         f(k,j,ico) = logc_ratio(k,i,2,icorr) * f(k,j,i1)
@@ -3606,10 +3828,12 @@
                   iinc = SIGN( 1, logc(k,i,2) )
                   i1   = ABS( logc(k,i,2) )
-                  DO  icorr = 0, ncorr - 1
+                  DO  icorr = 0, ncorr-1
                      ico = i + iinc * icorr
-                     DO  kcorr = 0, ncorr - 1
+                     DO  kcorr = 0, ncorr-1
                         kco = k + kcorr
-                        f(kco,i,ico) = 0.5_wp * ( logc_ratio(k,i,1,kcorr) * f(k1,j,i)  &
-                                     + logc_ratio(k,i,2,icorr) * f(k,j,i1) )
+                        f(kco,i,ico) = 0.5_wp * ( logc_ratio(k,i,1,kcorr) *    &
+                                                  f(k1,j,i)  &
+                                                + logc_ratio(k,i,2,icorr) *    &
+                                                  f(k,j,i1) )
                      ENDDO
                   ENDDO
@@ -3625,5 +3849,5 @@
          IF ( edge == 's' )  THEN
             DO  i = nxl, nxr + 1
-               DO  k = kb(j,i), nzt + 1
+               DO  k = kb(j,i), nzt+1
                   f(k,j,i) = tkefactor_s(k,i) * f(k,j,i)
                ENDDO
@@ -3631,5 +3855,5 @@
          ELSEIF ( edge == 'n' )  THEN
             DO  i = nxl, nxr + 1
-               DO  k = kb(j,i), nzt + 1
+               DO  k = kb(j,i), nzt+1
                   f(k,j,i) = tkefactor_n(k,i) * f(k,j,i)
                ENDDO
@@ -3641,9 +3865,9 @@
 !--   Store the boundary values also into the other redundant ghost node layers
       IF ( edge == 's' )  THEN
-         DO jbgp = -nbgp, jb
+         DO  jbgp = -nbgp, jb
             f(0:nzt+1,jbgp,nxlg:nxrg) = f(0:nzt+1,j,nxlg:nxrg)
          ENDDO
-      ELSE IF ( edge == 'n' )  THEN
-         DO jbgp = jb, ny + nbgp
+      ELSEIF ( edge == 'n' )  THEN
+         DO  jbgp = jb, ny+nbgp
             f(0:nzt+1,jbgp,nxlg:nxrg) = f(0:nzt+1,j,nxlg:nxrg)
          ENDDO
@@ -3654,5 +3878,6 @@
  
 
-   SUBROUTINE pmci_interp_tril_t( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, r2z, var )
+   SUBROUTINE pmci_interp_tril_t( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z,  &
+                                  r2z, var )
 
 !
@@ -3660,18 +3885,21 @@
 !--   conditions. This subroutine handles the top boundary. 
 !--   This subroutine is based on trilinear interpolation.
-!--   Constant dz is still assumed.
+
       IMPLICIT NONE
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  f     !:
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN)        ::  fc    !:
-      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)                        ::  r1x   !:
-      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)                        ::  r2x   !:
-      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)                        ::  r1y   !:
-      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)                        ::  r2y   !:
-      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)                        ::  r1z   !:
-      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)                        ::  r2z   !:
+
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
+                                      INTENT(INOUT) ::  f     !:
+      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
+                                      INTENT(IN)    ::  fc    !:
+      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r1x   !:
+      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r2x   !:
+      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r1y   !:
+      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r2y   !:
+      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z   !:
+      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z   !:
       
-      INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN)                    ::  ic    !:
-      INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)                    ::  jc    !:
-      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)                    ::  kc    !:
+      INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN) ::  ic    !:
+      INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN) ::  jc    !:
+      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN) ::  kc    !:
       
       CHARACTER(LEN=1), INTENT(IN) :: var   !:
@@ -3701,6 +3929,6 @@
       ENDIF
      
-      DO  i = nxl - 1, nxr + 1
-         DO  j = nys - 1, nyn + 1
+      DO  i = nxl-1, nxr+1
+         DO  j = nys-1, nyn+1
             l = ic(i)
             m = jc(j)
@@ -3724,7 +3952,7 @@
 !
 !--   Rescale if f is the TKE.
-!--   It is assumed that the bottom surface never reaches the top 
-!---  boundary of a nest domain. 
-      IF ( var == 'e')  THEN
+!--   It is assumed that the bottom surface never reaches the top boundary of a
+!--   nest domain.
+      IF ( var == 'e' )  THEN
          DO  i = nxl, nxr
             DO  j = nys, nyn
@@ -3746,4 +3974,5 @@
 !--    subroutine handles the left and right boundaries. However, this operation
 !--    is only needed in case of one-way coupling.
+
        IMPLICIT NONE
 
@@ -3785,6 +4014,6 @@
        ENDIF
 
-       DO  j = nys, nyn + 1
-          DO  k = kb(j,i), nzt +1
+       DO  j = nys, nyn+1
+          DO  k = kb(j,i), nzt+1
              vdotnor = outnor * u(k,j,ied)
 !
@@ -3806,5 +4035,5 @@
           ENDDO
        ELSEIF ( edge == 'r' )  THEN
-          DO ibgp = ib, nx + nbgp
+          DO ibgp = ib, nx+nbgp
              f(0:nzt+1,nysg:nyng,ibgp) = f(0:nzt+1,nysg:nyng,i)
           ENDDO
@@ -3822,4 +4051,5 @@
 !--    interpolated values by values extrapolated from the domain. This
 !--    subroutine handles the south and north boundaries.
+
        IMPLICIT NONE
 
@@ -3861,6 +4091,6 @@
        ENDIF
 
-       DO  i = nxl, nxr + 1
-          DO  k = kb(j,i), nzt + 1
+       DO  i = nxl, nxr+1
+          DO  k = kb(j,i), nzt+1
              vdotnor = outnor * v(k,jed,i)
 !
@@ -3878,9 +4108,9 @@
 !--    Store the boundary values also into the redundant ghost node layers.
        IF ( edge == 's' )  THEN
-          DO jbgp = -nbgp, jb
+          DO  jbgp = -nbgp, jb
              f(0:nzt+1,jbgp,nxlg:nxrg) = f(0:nzt+1,j,nxlg:nxrg)
           ENDDO
        ELSEIF ( edge == 'n' )  THEN
-          DO jbgp = jb, ny + nbgp
+          DO  jbgp = jb, ny+nbgp
              f(0:nzt+1,jbgp,nxlg:nxrg) = f(0:nzt+1,j,nxlg:nxrg)
           ENDDO
@@ -3896,4 +4126,5 @@
 !--    conditions. This subroutine handles the top boundary. It is based on
 !--    trilinear interpolation.
+
        IMPLICIT NONE
 
@@ -3941,5 +4172,5 @@
 
     SUBROUTINE pmci_anterp_tophat( f, fc, kct, ifl, ifu, jfl, jfu, kfl, kfu,   &
-                                   kb, var )
+                                   var )
 !
 !--    Anterpolation of internal-node values to be used as the server-domain
@@ -3947,4 +4178,5 @@
 !--    integration of the fine-grid values contained within the coarse-grid
 !--    cell.
+
        IMPLICIT NONE
 
@@ -3968,12 +4200,10 @@
        INTEGER(iwp), INTENT(IN) ::  kct   !:
 
-       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN)             ::  ifl   !:
-       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN)             ::  ifu   !:
-       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN)             ::  jfl   !:
-       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN)             ::  jfu   !:
-!--    TO_DO: is the next line really unnecessary?
-       INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN) ::  kb    !: may be unnecessary
-       INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)               ::  kfl   !:
-       INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)               ::  kfu   !:
+       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl   !:
+       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu   !:
+       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl   !:
+       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu   !:
+       INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl   !:
+       INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu   !:
 
 
@@ -4049,6 +4279,8 @@
                    ENDIF
                 ENDIF
-
-                fc(kk,jj,ii) = ( 1.0_wp - fra ) * fc(kk,jj,ii) +                 &
+!
+!--             TO DO: introduce 3-d coarse grid array for precomputed
+!--             1/REAL(nfc) values
+                fc(kk,jj,ii) = ( 1.0_wp - fra ) * fc(kk,jj,ii) +               &
                                fra * cellsum / REAL( nfc, KIND = wp )
 
Index: palm/trunk/SOURCE/pmc_server.f90
===================================================================
--- palm/trunk/SOURCE/pmc_server.f90	(revision 1796)
+++ palm/trunk/SOURCE/pmc_server.f90	(revision 1797)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-!
+! introduction of different datatransfer modes
 !
 ! Former revisions:
@@ -498,8 +498,15 @@
       REAL(wp), POINTER, DIMENSION(:,:,:) ::  data_3d
 
-      t1 = PMC_Time()
-      CALL MPI_Barrier(Clients(ClientId)%intra_comm, ierr)              ! Wait for buffer empty
-      t2 = PMC_Time()
-      if(present(WaitTime)) WaitTime = t2-t1
+!--   Synchronization of the model is done in pmci_client_synchronize and pmci_server_synchronize
+!--   Therefor the RMA window cann be filled without sychronization at this point and the barrier
+!--   is not necessary
+!--   Please note that WaitTime has to be set in PMC_S_FillBuffer AND PMC_C_GetBuffer
+
+      if(present(WaitTime)) then
+        t1 = PMC_Time()
+        CALL MPI_Barrier(Clients(ClientId)%intra_comm, ierr)
+        t2 = PMC_Time()
+        WaitTime = t2-t1
+      end if
 
       do ip=1,Clients(ClientId)%inter_npes
